'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tslib = require('tslib');
var React = require('react');
var mergeRefs = require('react-merge-refs');
var cn = require('classnames');
var hooks = require('@alfalab/hooks');
var CheckmarkCompactMIcon = require('@alfalab/icons-glyph/CheckmarkCompactMIcon');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);
var mergeRefs__default = /*#__PURE__*/_interopDefaultCompat(mergeRefs);
var cn__default = /*#__PURE__*/_interopDefaultCompat(cn);

var styles = {"component":"checkbox__component_16h33","start":"checkbox__start_16h33","center":"checkbox__center_16h33","addons":"checkbox__addons_16h33","block":"checkbox__block_16h33","box":"checkbox__box_16h33","checkedIcon":"checkbox__checkedIcon_16h33","s":"checkbox__s_16h33","disabled":"checkbox__disabled_16h33","checked":"checkbox__checked_16h33","indeterminate":"checkbox__indeterminate_16h33","indeterminateLine":"checkbox__indeterminateLine_16h33","label":"checkbox__label_16h33","hint":"checkbox__hint_16h33","focused":"checkbox__focused_16h33","content":"checkbox__content_16h33","errorMessage":"checkbox__errorMessage_16h33"};
require('./index.css')

var Checkbox = React.forwardRef(function (_a, ref) {
    var _b;
    var checked = _a.checked, label = _a.label, hint = _a.hint, _c = _a.size, size = _c === void 0 ? 's' : _c, boxClassName = _a.boxClassName, contentClassName = _a.contentClassName, _d = _a.align, align = _d === void 0 ? 'start' : _d, addons = _a.addons, block = _a.block, onChange = _a.onChange, className = _a.className, name = _a.name, disabled = _a.disabled, inactive = _a.inactive, dataTestId = _a.dataTestId, _e = _a.indeterminate, indeterminate = _e === void 0 ? false : _e, _f = _a.hiddenInput, hiddenInput = _f === void 0 ? false : _f, labelProps = _a.labelProps, error = _a.error, restProps = tslib.__rest(_a, ["checked", "label", "hint", "size", "boxClassName", "contentClassName", "align", "addons", "block", "onChange", "className", "name", "disabled", "inactive", "dataTestId", "indeterminate", "hiddenInput", "labelProps", "error"]);
    var labelRef = React.useRef(null);
    var focused = hooks.useFocus(labelRef, 'keyboard')[0];
    var handleChange = function (event) {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name: name });
        }
    };
    var errorMessage = typeof error === 'boolean' ? '' : error;
    return (React__default.default.createElement("label", tslib.__assign({}, labelProps, { className: cn__default.default(styles.component, styles[size], styles[align], className, labelProps === null || labelProps === void 0 ? void 0 : labelProps.className, (_b = {},
            _b[styles.disabled] = disabled || inactive,
            _b[styles.checked] = checked,
            _b[styles.indeterminate] = indeterminate,
            _b[styles.focused] = focused,
            _b[styles.block] = block,
            _b)), ref: mergeRefs__default.default([labelRef, ref, labelProps === null || labelProps === void 0 ? void 0 : labelProps.ref]) }),
        !hiddenInput && (React__default.default.createElement("input", tslib.__assign({ type: 'checkbox', onChange: handleChange, disabled: disabled || inactive, checked: checked, "data-test-id": dataTestId }, restProps))),
        React__default.default.createElement("span", { className: cn__default.default(styles.box, boxClassName) },
            checked && React__default.default.createElement(CheckmarkCompactMIcon.CheckmarkCompactMIcon, { className: styles.checkedIcon }),
            indeterminate && !checked && React__default.default.createElement("span", { className: styles.indeterminateLine })),
        (label || hint || errorMessage) && (React__default.default.createElement("span", { className: cn__default.default(styles.content, contentClassName) },
            label && React__default.default.createElement("span", { className: styles.label }, label),
            hint && !errorMessage && React__default.default.createElement("span", { className: styles.hint }, hint),
            errorMessage && (React__default.default.createElement("span", { className: styles.errorMessage, role: 'alert' }, errorMessage)))),
        addons && React__default.default.createElement("span", { className: styles.addons }, addons)));
});
/**
 * Для отображения в сторибуке
 */
Checkbox.defaultProps = {
    indeterminate: false,
};

exports.Checkbox = Checkbox;
